### Name: selectSubset
### Title: Select subset
### Aliases: selectSamples selectSubset
### Keywords: manip database

### ** Examples

# permanent selection, the variables 'WR' and 'labels' affected
selectSubset("SiO2>70") 

# back to the complete, originally loaded dataset
selectAll() 

# both expressions below return only sample names of analyses fulfilling 
# the given criteria, variables 'WR' and 'labels' NOT affected
selectSamples("SiO2<70&MgO>5")
selectSubset("SiO2<70&MgO>5",save=FALSE)  

## Not run: 
##D #EXAMPLES OF SEARCHING PATTERNS
##D # Searching by sample name
##D 
##D The sample names are: Bl-1, Bl-3, Koz-1, Koz-2, 
##D Koz-5, Koz-11, KozD-1, Ri-1.
##D 
##D oz-[1-3]    
##D # Samples Koz-1, Koz-2, Koz-11
##D 
##D oz-|Bl- 
##D # Samples Bl-1, Bl-2, Bl-3, Koz-1, Koz-2, Koz-5, Koz-11
##D 
##D # Searching by range
##D 
##D 1:5
##D # First to fifth samples in the data set
##D 
##D 1,10
##D # First and tenth samples
##D 
##D 1:5, 10:11, 25  
##D # Samples number 1,  2, ...5, 10, 11, 25
##D 
##D # Searching by Boolean
##D ######################
##D 
##D Intrusion="Rum"
##D # Finds all analyses from Rum
##D 
##D Intrusion="Rum".and.SiO2>65
##D Intrusion="Rum".AND.SiO2>65
##D Intrusion="Rum"&SiO2>65
##D # All analyses from Rum with silica greater than 65 
##D # (all three expressions are equivalent) 
##D 
##D 
##D MgO>10&(Locality="Skye"|Locality="Islay")
##D # All analyses from Skye or Islay with MgO greater than 10
##D 
##D Locality="^S"
##D # All analyses from any locality whose name starts with capital S
## End(Not run)



