### Name: spider
### Title: Spider plot(s): Selected samples
### Aliases: spiderplot.r spider spider.individual spider.contour
### Keywords: hplot

### ** Examples

ee<-spider.contour("Boynton","SiO2","reds",pch="*",cex=2,ymin=0.01,ymax=1000)

ee<-spider(WR,"Boynton",0.1,1000,pch="*",col="red",cex=2) # the ee<- construction redirects the textual output

ee<-spider(WR[1:15,],"Boynton",1,500,pch=1:15,col=1:15,legend=TRUE)

ee<-spider(WR,"Boynton",field=TRUE,density=0.02,angle=60,col="darkred",fill.col=FALSE,0.1,1000)

ee<-spider(WR,"Boynton",field=TRUE,fill.col=TRUE,shaded.col="khaki",0.1,1000)

# Shade the background field portraying the overall variation 
ee<-spider(WR,"Boynton",0.1,1000,pch=labels$Symbol,col=labels$Colour,cex=labels$Size)
ee<-spider(WR,"Boynton",field=TRUE,density=0.02,angle=45,col="gray",fill.col=FALSE,add=TRUE)   
    
# Shade the background field portraying the overall variation 
ee<-spider(WR,"Boynton",0.1,1000,pch=labels$Symbol,col=labels$Colour,cex=labels$Size)
ee<-spider(WR,"Boynton",field=TRUE,fill.col=TRUE,shaded.col="gray",add=TRUE)

# Possible styles for x axis
multiplePerPage(8,nrow=2,ncol=4,"Possible x axis styles", dummy=FALSE)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=F, xrotate=F, centered=F, 
    main="offset=F, xrotate=F, centered=F",new=F)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=F, xrotate=T, centered=F, 
    main="offset=F, xrotate=T, centered=F",new=F)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=F, xrotate=F, centered=T, 
    main="offset=F, xrotate=F, centered=T",new=F)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=F, xrotate=T, centered=T, 
    main="offset=F, xrotate=T, centered=T",new=F)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=T, xrotate=F, centered=F, 
    main="offset=T, xrotate=F, centered=F",new=F)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=T, xrotate=T, centered=F, 
    main="offset=T, xrotate=T, centered=F",new=F)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=T, xrotate=F, centered=T, 
    main="offset=T, xrotate=F, centered=T",new=F)
ee<-spider(WR, "Boynton", 0.1, 1000, pch=labels$Symbol, 
    col=labels$Colour, cex=labels$Size, offset=T, xrotate=T, centered=T, 
    main="offset=T, xrotate=T, centered=T",new=F)

spider(WR,"Boynton",plot=FALSE) # Calculation only



